/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
ldse@hendriklipka.de
*/

package de.hendriklipka.ldse.client;

import java.io.Writer;
import java.io.IOException;

/**
  Basisklasse fuer die Erzeugung von Anfragen
*/
public abstract class QueryGenerator
{
  protected double _minLevel=0;
  protected int _maxDoc=0;
  
  public abstract void init();
  public abstract void writeQuery(Writer writer) throws IOException;

  public void setLimits(int maxDoc, double minLevel)
  {
    _minLevel=minLevel;
    _maxDoc=maxDoc;
  }
  
  public void writeLimits(Writer writer) throws IOException
  {
    writer.write("<limit maxcount=\""+_maxDoc+"\" minlevel=\""+_minLevel+"\"/>");
    writer.flush();
  }
  
  public void writeTrailer(Writer writer) throws IOException
  {
    writer.write("<query>");
    writer.flush();
  }
  
  public void writeFooter(Writer writer) throws IOException
  {
    writer.write("</query>");
    writer.flush();
  }
}