/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
ldse@hendriklipka.de
*/

package de.hendriklipka.ldse.client.ui;

import java.awt.*;
import java.applet.*;
import java.net.*;

import de.hendriklipka.ldse.client.ClientConfig;

/**
  Hauptprogramm
  laeuft sowohl als Applet als auch als Applikation
*/
public class LDSEClient extends java.applet.Applet implements FrameHandler
{
  /** 
    Start als Applet
    dann wird das Copyright  und ein Button angezeigt
    ausserdem wird ein QueryFrame erzeugt
  */
	public void init()
	{
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(514,392);
		buttonCreateFrame.setLabel(lDSEClientBundle.getString("buttonCreateFrame_label"));
		add(buttonCreateFrame);
		buttonCreateFrame.setBounds(173,330,168,40);
		labelTitel1.setText(lDSEClientBundle.getString("labelTitel1_text"));
		labelTitel1.setAlignment(java.awt.Label.CENTER);
		add(labelTitel1);
		labelTitel1.setFont(new Font("Dialog", Font.BOLD, 24));
		labelTitel1.setBounds(8,30,498,40);
		labelTitel2.setText(lDSEClientBundle.getString("labelTitel2_text"));
		labelTitel2.setAlignment(java.awt.Label.CENTER);
		add(labelTitel2);
		labelTitel2.setFont(new Font("Dialog", Font.PLAIN, 24));
		labelTitel2.setBounds(207,108,100,40);
		labelCopyright.setText(lDSEClientBundle.getString("labelCopyright_text"));
		labelCopyright.setAlignment(java.awt.Label.CENTER);
		add(labelCopyright);
		labelCopyright.setBounds(71,192,372,28);

		SymAction lSymAction = new SymAction();
		buttonCreateFrame.addActionListener(lSymAction);

		_config=new ClientConfig(this);
		buttonCreateFrame_ActionPerformed(null);
  }
	
	
	java.awt.Button buttonCreateFrame = new java.awt.Button();
	java.awt.Label labelTitel1 = new java.awt.Label();
	java.awt.Label labelTitel2 = new java.awt.Label();
	java.awt.Label labelCopyright = new java.awt.Label();

	QueryFrame _queryFrame=null;
	Object _qfSync=new Object();
	ResultFrame _resultFrame=null;
	
	ClientConfig _config=null;
	
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == buttonCreateFrame)
				buttonCreateFrame_ActionPerformed(event);
		}
	}

  /**
    wenn noch ein Suchfenster da ist, dieses anzeigen
    ansonsten wird ein neues erzeugt
  */
	void buttonCreateFrame_ActionPerformed(java.awt.event.ActionEvent event)
	{
	  if (null==_queryFrame)
	  {
	    synchronized(_qfSync)
	    {
	      if (null==_queryFrame)
	      {
  	      _queryFrame=new QueryFrame(this,_config);
		      QueryPanel simple=new SimpleQueryPanel(_queryFrame);
		      QueryPanel cq=new ComplexQueryPanel(_queryFrame);
		      _queryFrame.addQueryMethod(simple);
		      _queryFrame.addQueryMethod(cq);
		      _queryFrame.init();
  	    }
	    }
	  }
	  _queryFrame.show();
	}
	
	public ResultFrame getResultFrame()
	{
	  return _resultFrame;
	}
	
	public void setResultFrame(ResultFrame f)
	{
	  _resultFrame=f;
	}
	
	public QueryFrame getQueryFrame()
	{
	  return _queryFrame;
	}
	
	public void setQueryFrame(QueryFrame f)
	{
	  _queryFrame=f;
	}
	
  public String[][] getParameterInfo()
  {
    String pinfo[][] = {
	    {ClientConfig._serverIPString, "IP", lDSEClientBundle.getString("ClientConfig__serverIPString__lDSEClientBundle_getString")},
	    {ClientConfig._serverPortString, "int", lDSEClientBundle.getString("port_of_server")}
    };
    return pinfo;
  }
  
  public String getAppletInfo()
  {
    return lDSEClientBundle.getString("LDSE_Applet_Version_1_0__C__Copyright");
  }

  /**
    Start als Applikation
    dann wird ein QueryFrane das Hauptfenster
  */
	public static void main(String args[])
	{
	  ClientConfig config=new ClientConfig(args);
	  
	  QueryFrame qf=new QueryFrame(null,config);
		QueryPanel simple=new SimpleQueryPanel(qf);
		QueryPanel cq=new ComplexQueryPanel(qf);
		qf.addQueryMethod(simple);
		qf.addQueryMethod(cq);
		qf.init();
	  qf.setVisible(true);
	}
	static java.util.ResourceBundle lDSEClientBundle = java.util.ResourceBundle.getBundle("de.hendriklipka.ldse.client.ui.LDSEClientBundle");
}
